/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Correlation Relationship</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getSources <em>Sources</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getDestination <em>Destination</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getSourceComponentInstanceReferences <em>Source Component Instance References</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getDestinationComponentInstanceReference <em>Destination Component Instance Reference</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCorrelationRelationship()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='NumberOfSourceInfluencingParametersEqualToSourceComponentInstanceReferences DelegationOnlyAllowedWithSingleSource'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot NumberOfSourceInfluencingParametersEqualToSourceComponentInstanceReferences='\n\t\t\tsources->size() = destination->size()' DelegationOnlyAllowedWithSingleSource='\n\t\t\tself.characterization = RelationshipCharacterizationType::IDENTITY implies sources->size() = 1'"
 * @generated
 */
public interface CorrelationRelationship extends Relationship {
	/**
	 * Returns the value of the '<em><b>Sources</b></em>' reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sources</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sources</em>' reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCorrelationRelationship_Sources()
	 * @model required="true"
	 * @generated
	 */
	EList<InfluencingParameter> getSources();

	/**
	 * Returns the value of the '<em><b>Destination</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Destination</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Destination</em>' reference.
	 * @see #setDestination(InfluencingParameter)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCorrelationRelationship_Destination()
	 * @model required="true"
	 * @generated
	 */
	InfluencingParameter getDestination();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getDestination <em>Destination</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Destination</em>' reference.
	 * @see #getDestination()
	 * @generated
	 */
	void setDestination(InfluencingParameter value);

	/**
	 * Returns the value of the '<em><b>Source Component Instance References</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ComponentInstanceReference}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source Component Instance References</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source Component Instance References</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCorrelationRelationship_SourceComponentInstanceReferences()
	 * @model containment="true" required="true"
	 * @generated
	 */
	EList<ComponentInstanceReference> getSourceComponentInstanceReferences();

	/**
	 * Returns the value of the '<em><b>Destination Component Instance Reference</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Destination Component Instance Reference</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Destination Component Instance Reference</em>' containment reference.
	 * @see #setDestinationComponentInstanceReference(ComponentInstanceReference)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getCorrelationRelationship_DestinationComponentInstanceReference()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ComponentInstanceReference getDestinationComponentInstanceReference();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.CorrelationRelationship#getDestinationComponentInstanceReference <em>Destination Component Instance Reference</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Destination Component Instance Reference</em>' containment reference.
	 * @see #getDestinationComponentInstanceReference()
	 * @generated
	 */
	void setDestinationComponentInstanceReference(ComponentInstanceReference value);

} // CorrelationRelationship
