/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceRequiringRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>External Call</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall#getSignature <em>Signature</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall#getInterfaceRequiringRole <em>Interface Requiring Role</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getExternalCall()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='SignatureBelongsToInterfaceRequiringRole'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot SignatureBelongsToInterfaceRequiringRole='self.interfaceRequiringRole.interface.signatures->includes(self.signature)'"
 * @generated
 */
public interface ExternalCall extends EObject {
	/**
	 * Returns the value of the '<em><b>Signature</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Signature</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Signature</em>' reference.
	 * @see #setSignature(Signature)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getExternalCall_Signature()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	Signature getSignature();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall#getSignature <em>Signature</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Signature</em>' reference.
	 * @see #getSignature()
	 * @generated
	 */
	void setSignature(Signature value);

	/**
	 * Returns the value of the '<em><b>Interface Requiring Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Requiring Role</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interface Requiring Role</em>' reference.
	 * @see #setInterfaceRequiringRole(InterfaceRequiringRole)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getExternalCall_InterfaceRequiringRole()
	 * @model required="true" ordered="false"
	 * @generated
	 */
	InterfaceRequiringRole getInterfaceRequiringRole();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCall#getInterfaceRequiringRole <em>Interface Requiring Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interface Requiring Role</em>' reference.
	 * @see #getInterfaceRequiringRole()
	 * @generated
	 */
	void setInterfaceRequiringRole(InterfaceRequiringRole value);

} // ExternalCall
