/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.BasicComponent;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ComponentInternalBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.FineGrainedBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Fine Grained Behavior</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.FineGrainedBehaviorImpl#getBasicComponent <em>Basic Component</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.FineGrainedBehaviorImpl#getBehavior <em>Behavior</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FineGrainedBehaviorImpl extends ServiceBehaviorAbstractionImpl implements FineGrainedBehavior {
	/**
	 * The cached value of the '{@link #getBasicComponent() <em>Basic Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBasicComponent()
	 * @generated
	 * @ordered
	 */
	protected BasicComponent basicComponent;

	/**
	 * The cached value of the '{@link #getBehavior() <em>Behavior</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBehavior()
	 * @generated
	 * @ordered
	 */
	protected ComponentInternalBehavior behavior;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FineGrainedBehaviorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.FINE_GRAINED_BEHAVIOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BasicComponent getBasicComponent() {
		if (basicComponent != null && basicComponent.eIsProxy()) {
			InternalEObject oldBasicComponent = (InternalEObject)basicComponent;
			basicComponent = (BasicComponent)eResolveProxy(oldBasicComponent);
			if (basicComponent != oldBasicComponent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BASIC_COMPONENT, oldBasicComponent, basicComponent));
			}
		}
		return basicComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BasicComponent basicGetBasicComponent() {
		return basicComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBasicComponent(BasicComponent newBasicComponent) {
		BasicComponent oldBasicComponent = basicComponent;
		basicComponent = newBasicComponent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BASIC_COMPONENT, oldBasicComponent, basicComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentInternalBehavior getBehavior() {
		return behavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBehavior(ComponentInternalBehavior newBehavior, NotificationChain msgs) {
		ComponentInternalBehavior oldBehavior = behavior;
		behavior = newBehavior;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR, oldBehavior, newBehavior);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBehavior(ComponentInternalBehavior newBehavior) {
		if (newBehavior != behavior) {
			NotificationChain msgs = null;
			if (behavior != null)
				msgs = ((InternalEObject)behavior).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR, null, msgs);
			if (newBehavior != null)
				msgs = ((InternalEObject)newBehavior).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR, null, msgs);
			msgs = basicSetBehavior(newBehavior, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR, newBehavior, newBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR:
				return basicSetBehavior(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BASIC_COMPONENT:
				if (resolve) return getBasicComponent();
				return basicGetBasicComponent();
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR:
				return getBehavior();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BASIC_COMPONENT:
				setBasicComponent((BasicComponent)newValue);
				return;
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR:
				setBehavior((ComponentInternalBehavior)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BASIC_COMPONENT:
				setBasicComponent((BasicComponent)null);
				return;
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR:
				setBehavior((ComponentInternalBehavior)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BASIC_COMPONENT:
				return basicComponent != null;
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR__BEHAVIOR:
				return behavior != null;
		}
		return super.eIsSet(featureID);
	}

} //FineGrainedBehaviorImpl
