/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.predictionset.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.system.SystemPackage;

import edu.kit.ipd.descartes.mm.deployment.DeploymentPackage;

import edu.kit.ipd.descartes.mm.predictionset.PredictionSet;
import edu.kit.ipd.descartes.mm.predictionset.PredictionSetFactory;
import edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage;

import edu.kit.ipd.descartes.mm.predictionset.util.PredictionSetValidator;

import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage;

import edu.kit.ipd.descartes.mm.workload.WorkloadPackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PredictionSetPackageImpl extends EPackageImpl implements PredictionSetPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass predictionSetEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see edu.kit.ipd.descartes.mm.predictionset.PredictionSetPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private PredictionSetPackageImpl() {
		super(eNS_URI, PredictionSetFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link PredictionSetPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static PredictionSetPackage init() {
		if (isInited) return (PredictionSetPackage)EPackage.Registry.INSTANCE.getEPackage(PredictionSetPackage.eNS_URI);

		// Obtain or create and register package
		PredictionSetPackageImpl thePredictionSetPackage = (PredictionSetPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof PredictionSetPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new PredictionSetPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		DeploymentPackage.eINSTANCE.eClass();
		WorkloadPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		thePredictionSetPackage.createPackageContents();

		// Initialize created meta-data
		thePredictionSetPackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put
			(thePredictionSetPackage, 
			 new EValidator.Descriptor() {
				 public EValidator getEValidator() {
					 return PredictionSetValidator.INSTANCE;
				 }
			 });

		// Mark meta-data to indicate it can't be changed
		thePredictionSetPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(PredictionSetPackage.eNS_URI, thePredictionSetPackage);
		return thePredictionSetPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPredictionSet() {
		return predictionSetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPredictionSet_WorkloadModel() {
		return (EReference)predictionSetEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPredictionSet_DeploymentModel() {
		return (EReference)predictionSetEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPredictionSet_SystemModel() {
		return (EReference)predictionSetEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPredictionSet_RepositoryModel() {
		return (EReference)predictionSetEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPredictionSet_ResourcelandscapeModel() {
		return (EReference)predictionSetEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredictionSetFactory getPredictionSetFactory() {
		return (PredictionSetFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		predictionSetEClass = createEClass(PREDICTION_SET);
		createEReference(predictionSetEClass, PREDICTION_SET__WORKLOAD_MODEL);
		createEReference(predictionSetEClass, PREDICTION_SET__DEPLOYMENT_MODEL);
		createEReference(predictionSetEClass, PREDICTION_SET__SYSTEM_MODEL);
		createEReference(predictionSetEClass, PREDICTION_SET__REPOSITORY_MODEL);
		createEReference(predictionSetEClass, PREDICTION_SET__RESOURCELANDSCAPE_MODEL);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		WorkloadPackage theWorkloadPackage = (WorkloadPackage)EPackage.Registry.INSTANCE.getEPackage(WorkloadPackage.eNS_URI);
		DeploymentPackage theDeploymentPackage = (DeploymentPackage)EPackage.Registry.INSTANCE.getEPackage(DeploymentPackage.eNS_URI);
		SystemPackage theSystemPackage = (SystemPackage)EPackage.Registry.INSTANCE.getEPackage(SystemPackage.eNS_URI);
		RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);
		ResourcelandscapePackage theResourcelandscapePackage = (ResourcelandscapePackage)EPackage.Registry.INSTANCE.getEPackage(ResourcelandscapePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes

		// Initialize classes and features; add operations and parameters
		initEClass(predictionSetEClass, PredictionSet.class, "PredictionSet", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPredictionSet_WorkloadModel(), theWorkloadPackage.getWorkload(), null, "workloadModel", null, 1, 1, PredictionSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getPredictionSet_DeploymentModel(), theDeploymentPackage.getDeployment(), null, "deploymentModel", null, 1, 1, PredictionSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getPredictionSet_SystemModel(), theSystemPackage.getSystem(), null, "systemModel", null, 1, 1, PredictionSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
		initEReference(getPredictionSet_RepositoryModel(), theRepositoryPackage.getRepository(), null, "repositoryModel", null, 1, -1, PredictionSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
		initEReference(getPredictionSet_ResourcelandscapeModel(), theResourcelandscapePackage.getDistributedDataCenter(), null, "resourcelandscapeModel", null, 1, 1, PredictionSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot
		createPivotAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";		
		addAnnotation
		  (this, 
		   source, 
		   new String[] {
			 "invocationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			 "settingDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			 "validationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"
		   });		
		addAnnotation
		  (predictionSetEClass, 
		   source, 
		   new String[] {
			 "constraints", "SystemModelReferencedByDeploymentModelAndWorkloadModelMustBeTheSame"
		   });				
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createPivotAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot";				
		addAnnotation
		  (predictionSetEClass, 
		   source, 
		   new String[] {
			 "SystemModelReferencedByDeploymentModelAndWorkloadModelMustBeTheSame", "systemModel = deploymentModel.system"
		   });		
		addAnnotation
		  (getPredictionSet_SystemModel(), 
		   source, 
		   new String[] {
			 "derivation", "workloadModel.system"
		   });		
		addAnnotation
		  (getPredictionSet_RepositoryModel(), 
		   source, 
		   new String[] {
			 "derivation", "systemModel->collect(r : _\'/resource/edu.kit.ipd.descartes.mm.applicationlevel/model/system.ecore\'::system::System | assemblyContexts.encapsulatedComponent.repository)->asSet()"
		   });		
		addAnnotation
		  (getPredictionSet_ResourcelandscapeModel(), 
		   source, 
		   new String[] {
			 "derivation", "deploymentModel.targetResourceLandscape"
		   });
	}

} //PredictionSetPackageImpl
