/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.workload.ScenarioBehavior;
import edu.kit.ipd.descartes.mm.workload.UsageScenario;
import edu.kit.ipd.descartes.mm.workload.Workload;
import edu.kit.ipd.descartes.mm.workload.WorkloadPackage;
import edu.kit.ipd.descartes.mm.workload.WorkloadType;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Usage Scenario</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.workload.impl.UsageScenarioImpl#getUsageModel <em>Usage Model</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.workload.impl.UsageScenarioImpl#getScenarioBehavior <em>Scenario Behavior</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.workload.impl.UsageScenarioImpl#getWorkloadType <em>Workload Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class UsageScenarioImpl extends EntityImpl implements UsageScenario {
	/**
	 * The cached value of the '{@link #getScenarioBehavior() <em>Scenario Behavior</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getScenarioBehavior()
	 * @generated
	 * @ordered
	 */
	protected ScenarioBehavior scenarioBehavior;

	/**
	 * The cached value of the '{@link #getWorkloadType() <em>Workload Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWorkloadType()
	 * @generated
	 * @ordered
	 */
	protected WorkloadType workloadType;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UsageScenarioImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return WorkloadPackage.Literals.USAGE_SCENARIO;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Workload getUsageModel() {
		if (eContainerFeatureID() != WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL) return null;
		return (Workload)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetUsageModel(Workload newUsageModel, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newUsageModel, WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUsageModel(Workload newUsageModel) {
		if (newUsageModel != eInternalContainer() || (eContainerFeatureID() != WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL && newUsageModel != null)) {
			if (EcoreUtil.isAncestor(this, newUsageModel))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newUsageModel != null)
				msgs = ((InternalEObject)newUsageModel).eInverseAdd(this, WorkloadPackage.WORKLOAD__USAGE_SCENARIOS, Workload.class, msgs);
			msgs = basicSetUsageModel(newUsageModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL, newUsageModel, newUsageModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScenarioBehavior getScenarioBehavior() {
		return scenarioBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetScenarioBehavior(ScenarioBehavior newScenarioBehavior, NotificationChain msgs) {
		ScenarioBehavior oldScenarioBehavior = scenarioBehavior;
		scenarioBehavior = newScenarioBehavior;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR, oldScenarioBehavior, newScenarioBehavior);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setScenarioBehavior(ScenarioBehavior newScenarioBehavior) {
		if (newScenarioBehavior != scenarioBehavior) {
			NotificationChain msgs = null;
			if (scenarioBehavior != null)
				msgs = ((InternalEObject)scenarioBehavior).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR, null, msgs);
			if (newScenarioBehavior != null)
				msgs = ((InternalEObject)newScenarioBehavior).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR, null, msgs);
			msgs = basicSetScenarioBehavior(newScenarioBehavior, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR, newScenarioBehavior, newScenarioBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WorkloadType getWorkloadType() {
		return workloadType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetWorkloadType(WorkloadType newWorkloadType, NotificationChain msgs) {
		WorkloadType oldWorkloadType = workloadType;
		workloadType = newWorkloadType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE, oldWorkloadType, newWorkloadType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setWorkloadType(WorkloadType newWorkloadType) {
		if (newWorkloadType != workloadType) {
			NotificationChain msgs = null;
			if (workloadType != null)
				msgs = ((InternalEObject)workloadType).eInverseRemove(this, WorkloadPackage.WORKLOAD_TYPE__USAGE_SCENARIO, WorkloadType.class, msgs);
			if (newWorkloadType != null)
				msgs = ((InternalEObject)newWorkloadType).eInverseAdd(this, WorkloadPackage.WORKLOAD_TYPE__USAGE_SCENARIO, WorkloadType.class, msgs);
			msgs = basicSetWorkloadType(newWorkloadType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE, newWorkloadType, newWorkloadType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetUsageModel((Workload)otherEnd, msgs);
			case WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE:
				if (workloadType != null)
					msgs = ((InternalEObject)workloadType).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE, null, msgs);
				return basicSetWorkloadType((WorkloadType)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL:
				return basicSetUsageModel(null, msgs);
			case WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR:
				return basicSetScenarioBehavior(null, msgs);
			case WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE:
				return basicSetWorkloadType(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL:
				return eInternalContainer().eInverseRemove(this, WorkloadPackage.WORKLOAD__USAGE_SCENARIOS, Workload.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL:
				return getUsageModel();
			case WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR:
				return getScenarioBehavior();
			case WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE:
				return getWorkloadType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL:
				setUsageModel((Workload)newValue);
				return;
			case WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR:
				setScenarioBehavior((ScenarioBehavior)newValue);
				return;
			case WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE:
				setWorkloadType((WorkloadType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL:
				setUsageModel((Workload)null);
				return;
			case WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR:
				setScenarioBehavior((ScenarioBehavior)null);
				return;
			case WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE:
				setWorkloadType((WorkloadType)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case WorkloadPackage.USAGE_SCENARIO__USAGE_MODEL:
				return getUsageModel() != null;
			case WorkloadPackage.USAGE_SCENARIO__SCENARIO_BEHAVIOR:
				return scenarioBehavior != null;
			case WorkloadPackage.USAGE_SCENARIO__WORKLOAD_TYPE:
				return workloadType != null;
		}
		return super.eIsSet(featureID);
	}

} //UsageScenarioImpl
