/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.workload.impl;

import edu.kit.ipd.descartes.mm.workload.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class WorkloadFactoryImpl extends EFactoryImpl implements WorkloadFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static WorkloadFactory init() {
		try {
			WorkloadFactory theWorkloadFactory = (WorkloadFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.descartes-research.net/metamodel/workload/0.1"); 
			if (theWorkloadFactory != null) {
				return theWorkloadFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new WorkloadFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WorkloadFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case WorkloadPackage.WORKLOAD: return createWorkload();
			case WorkloadPackage.USAGE_SCENARIO: return createUsageScenario();
			case WorkloadPackage.SCENARIO_BEHAVIOR: return createScenarioBehavior();
			case WorkloadPackage.OPEN_WORKLOAD_TYPE: return createOpenWorkloadType();
			case WorkloadPackage.CLOSED_WORKLOAD_TYPE: return createClosedWorkloadType();
			case WorkloadPackage.LOOP_USER_ACTION: return createLoopUserAction();
			case WorkloadPackage.DELAY_USER_ACTION: return createDelayUserAction();
			case WorkloadPackage.BRANCH_USER_ACTION: return createBranchUserAction();
			case WorkloadPackage.ENTRY_LEVEL_SYSTEM_CALL: return createEntryLevelSystemCall();
			case WorkloadPackage.CALL_PARAMETER_SETTING: return createCallParameterSetting();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Workload createWorkload() {
		WorkloadImpl workload = new WorkloadImpl();
		return workload;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UsageScenario createUsageScenario() {
		UsageScenarioImpl usageScenario = new UsageScenarioImpl();
		return usageScenario;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScenarioBehavior createScenarioBehavior() {
		ScenarioBehaviorImpl scenarioBehavior = new ScenarioBehaviorImpl();
		return scenarioBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OpenWorkloadType createOpenWorkloadType() {
		OpenWorkloadTypeImpl openWorkloadType = new OpenWorkloadTypeImpl();
		return openWorkloadType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClosedWorkloadType createClosedWorkloadType() {
		ClosedWorkloadTypeImpl closedWorkloadType = new ClosedWorkloadTypeImpl();
		return closedWorkloadType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoopUserAction createLoopUserAction() {
		LoopUserActionImpl loopUserAction = new LoopUserActionImpl();
		return loopUserAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DelayUserAction createDelayUserAction() {
		DelayUserActionImpl delayUserAction = new DelayUserActionImpl();
		return delayUserAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BranchUserAction createBranchUserAction() {
		BranchUserActionImpl branchUserAction = new BranchUserActionImpl();
		return branchUserAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EntryLevelSystemCall createEntryLevelSystemCall() {
		EntryLevelSystemCallImpl entryLevelSystemCall = new EntryLevelSystemCallImpl();
		return entryLevelSystemCall;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallParameterSetting createCallParameterSetting() {
		CallParameterSettingImpl callParameterSetting = new CallParameterSettingImpl();
		return callParameterSetting;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WorkloadPackage getWorkloadPackage() {
		return (WorkloadPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static WorkloadPackage getPackage() {
		return WorkloadPackage.eINSTANCE;
	}

} //WorkloadFactoryImpl
